				/* expregas.y */
%{
#include <ctype.h>
#include "../AnalDesc/arbin.h"
#include "afnThomp.h"
void yyerror(char*);
int yylex();
char * invite="\nVeuillez saisir une expression régulière suivie de <Entrée> S.V.P.\n";
%}
%union {			/* YYSTYPE */
Arbin a;
int i;
}

%token<i> SYMBOLE CONCAT        /* definition des jetons */       
%type<a> expr           /* definition des types des non terminaux */

%left '|'
%left CONCAT SYMBOLE '('
%left '*'
%%

liste   :			/* chaine vide sur fin de fichier Ctrl-D */
        |       liste  ligne {puts(invite);}
        ;
ligne   :       '\n'            /* ligne vide : expression vide */
        |       error '\n'      {yyerrok; /* après la fin de ligne */}
        |       expr '\n'       
        {   puts("Arbre binaire de l'expression régulière\n");
	    ab_afficher($1); 
            if (ab_racine($1)=='0'){
                puts("\nLe langage de l'expression régulière est vide !\n");
            }else{
                puts("\nConstruction de l'Automate  ...\n");
                AFN b=afnCreer($1);  
		ab_vider($1);
                afnAfficher(b);
		afnVider(b);
		
            }
        }
        ;
expr    :       '(' expr ')'    {$$ = $2;}                   // parenthésage
        |       expr expr %prec CONCAT {$$= ab_construire('.',$1,$2);} // concat 
        |       expr '|' expr  {$$= ab_construire('|',$1,$3);} // UNION 
        |       expr '*'    {$$= ab_construire('*',$1,NULL); } // ETOILE
        |       SYMBOLE     {$$=ab_construire($1,NULL,NULL);} // symbole de base
        ;
%%
int yylex(){int i=getchar();
        if (islower(i)||i=='@'||i=='0') 
          {yylval.i=i;return SYMBOLE;} 
        else return i;
      }
void yyerror(char *s) {fprintf(stderr,"%s\n",s);}

int main(){/*yydebug=1;*/puts(invite);return yyparse();}
